// Bibliotecas necessárias ao uso do RFID
#include <SPI.h>
#include <MFRC522.h>

// Bibliotecas necessárias para utilizar o LCD
#include <Wire.h>
#include <LiquidCrystal_I2C.h>

#include <Servo.h> // Biblioteca para o funcionamento do servo

Servo servoE;
Servo servoS;
const int portServoE  = 6;
int servoEInicio      = 0;
int servoEFim         = 90;
const int portServoS  = 7;
int servoSInicio      = 90;
int servoSFim         = 0;
int servoTemp         = 30; // Delay de abertura ou fecho da cancela

bool querSair         = false; // Indique que o veículo vai entrar no parque

LiquidCrystal_I2C lcd(0x27, 16, 2); // O endereço do LCD, em príncipio, é 0x27
 
#define SS_PIN 10
#define RST_PIN 9
MFRC522 mfrc522(SS_PIN, RST_PIN);   // Cria o objeto mfrc522.
  
void setup(){
  Serial.begin(9600);
  lcd.init();
  lcd.setBacklight(HIGH);

  servoE.attach(portServoE);  
  servoS.attach(portServoS); 
  servoE.write(servoEInicio); // Inicializar o Servo na posição 0
  servoS.write(servoSInicio);
  
  SPI.begin();          // Inicia  SPI - Serial Peripheral Interface - bus que permite a comunicação entre os vários componentes
  mfrc522.PCD_Init();   // Inicia o leitor de cartões RFID
  Serial.println("Aproxima o cartao do leitor...");
  Serial.println();
  
}
 
void loop(){
  // Procura novos cartões
  if (mfrc522.PICC_IsNewCardPresent()){
    if (mfrc522.PICC_ReadCardSerial()){
      //Mostra UID no monitor serial
      Serial.print("UID da tag :");
      String conteudo= "";
      
      for (byte i = 0; i < mfrc522.uid.size; i++){
         Serial.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
         Serial.print(mfrc522.uid.uidByte[i], HEX);
         conteudo.concat(String(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " "));
         conteudo.concat(String(mfrc522.uid.uidByte[i], HEX));
      }
      Serial.println();
      Serial.print("Mensagem : ");
      conteudo.toUpperCase();
      lcd.clear();
      lcd.setCursor(0, 0);
      if (conteudo.substring(1) == "34 94 25 D9"){ //UID 1 - Chaveiro
        Serial.println("Ola RASCUNHOS !");
        Serial.println();
        if(!querSair){ // Entrada no parque
          lcd.print("Bem-vindo ao parque :D"); // escreve a mensagem        
          for (int i=servoEInicio; i<=servoEFim; i+=2){ // Criar um ciclo para abrir a cancela
            servoE.write(i);
            delay(servoTemp);
          }      
          delay(4000);      
          // Criar um ciclo para fechar a cancela
          for (int i=servoEFim; i>=servoEInicio; i-=2){
            servoE.write(i);
            delay(servoTemp);
          }
          querSair = true;
        } else {
          lcd.print("Obrigado, volte sempre!"); // escreve a mensagem        
          for (int i=servoSInicio; i>=servoSFim; i-=2){ // Criar um ciclo para abrir a cancela
            servoS.write(i);
            delay(servoTemp);
          }      
          delay(4000);      
          // Criar um ciclo para fechar a cancela
          for (int i=servoSFim; i<=servoSInicio; i+=2){
            servoS.write(i);
            delay(servoTemp);
          }
          querSair = false;
        }
      } else {
        Serial.println("Nao te conheço, quem es? :D ");
        Serial.println();
        lcd.print("Cartao Invalido :("); // escreve a mensagem        
      }  
      delay(2000);
      lcd.clear();
      lcd.print("Parque RASCUNHOS");
    }
  }
} 
